Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_EC_Servant_Var< T > Class Template Reference

`#include <EC_Lifetime_Utils_T.h>`

Inheritance diagram for TAO_EC_Servant_Var< T >:

[legend]
Collaboration diagram for TAO_EC_Servant_Var< T >:

[legend]
List of all members.

## Public Methods
| TAO_EC_Servant_Var (T *p=0)
| Constructor. Assumes ownership of `p`.
| TAO_EC_Servant_Var (TAO_EC_Servant_Var< T > const &rhs)
| Copy constructor. Adds reference to `rhs`.
TAO_EC_Servant_Var< T > & | operator= (TAO_EC_Servant_Var< T > const &rhs)
| Assignment operator. Adds reference to `rhs`.
| ~TAO_EC_Servant_Var ()
TAO_EC_Servant_Var< T > & | operator= (T *p)
| Assignment operator. Assumes ownership of `p`.
template<class Y> | TAO_EC_Servant_Var (Y *p)
template<class Y> | TAO_EC_Servant_Var (TAO_EC_Servant_Var< Y > const &rhs)
template<class Y> TAO_EC_Servant_Var< T > & | operator= (TAO_EC_Servant_Var< Y > const &rhs)
template<class Y> TAO_EC_Servant_Var< T > & | operator= (Y *p)
T const * | operator-> () const
| Smart pointer operator-> provides access to the underlying object.
T * | operator-> ()
| Smart pointer operator-> provides access to the underlying object.
T const & | operator * () const
| Dereference the underlying object.
T & | operator * ()
| Dereference the underlying object.
| operator void const * () const
T * | in () const
| As an IN parameter.
T *& | inout ()
| As an INOUT parameter.
T *& | out ()
| As an OUT parameter.
T * | _retn ()
## Private Attributes
T * | ptr_

### template<class T>
class TAO_EC_Servant_Var< T >

## Constructor & Destructor Documentation

template<class T>
ACE_INLINE TAO_EC_Servant_Var< T >::TAO_EC_Servant_Var | ( | T * | p = 0 | ) |

| Constructor. Assumes ownership of `p`.

template<class T>
ACE_INLINE TAO_EC_Servant_Var< T >::TAO_EC_Servant_Var | ( | TAO_EC_Servant_Var< T > const & | rhs | ) |

| Copy constructor. Adds reference to `rhs`.

template<class T>
ACE_INLINE TAO_EC_Servant_Var< T >::~TAO_EC_Servant_Var | ( |  | ) |

| Destructor. Removes a reference from the underlying object, possibly destroying it.

template<class T>
template<class Y>
ACE_INLINE TAO_EC_Servant_Var< T >::TAO_EC_Servant_Var | ( | Y * | p | ) |

| Template member constructor from a pointer that will implicitly cast to type T. Assumes ownership of `p`. This constructor allows constructs such as: Servant_Base<Base> p(new Derived);

template<class T>
template<class Y>
ACE_INLINE TAO_EC_Servant_Var< T >::TAO_EC_Servant_Var | ( | TAO_EC_Servant_Var< Y > const & | rhs | ) |

| Template member copy constructor from a TAO_EC_Servant_Var<Y>, where Y can be implicitly cast to type T.

## Member Function Documentation

template<class T>
ACE_INLINE T * TAO_EC_Servant_Var< T >::_retn | ( |  | ) |

template<class T>
ACE_INLINE T * TAO_EC_Servant_Var< T >::in | ( |  | ) |

| As an IN parameter.

template<class T>
ACE_INLINE T *& TAO_EC_Servant_Var< T >::inout | ( |  | ) |

| As an INOUT parameter.

template<class T>
ACE_INLINE T & TAO_EC_Servant_Var< T >::operator * | ( |  | ) |

| Dereference the underlying object.

template<class T>
ACE_INLINE T const & TAO_EC_Servant_Var< T >::operator * | ( |  | ) |

| Dereference the underlying object.

template<class T>
ACE_INLINE TAO_EC_Servant_Var< T >::operator void const * | ( |  | ) |

| Return a void pointer to the underlying object. This allows it to be used in conditional code and tested against 0.

template<class T>
ACE_INLINE T * TAO_EC_Servant_Var< T >::operator-> | ( |  | ) |

| Smart pointer operator-> provides access to the underlying object.

template<class T>
ACE_INLINE T const * TAO_EC_Servant_Var< T >::operator-> | ( |  | ) |

| Smart pointer operator-> provides access to the underlying object.

template<class T>
template<class Y>
ACE_INLINE TAO_EC_Servant_Var< T > & TAO_EC_Servant_Var< T >::operator= | ( | Y * | p | ) |

| Template member assignment operator from a pointer to Y, where Y can be implicitly cast to type T.

template<class T>
template<class Y>
ACE_INLINE TAO_EC_Servant_Var< T > & TAO_EC_Servant_Var< T >::operator= | ( | TAO_EC_Servant_Var< Y > const & | rhs | ) |

| Template member assignment operator from a TAO_EC_Servant_Var<Y>, where Y can be implicitly cast to type T.

template<class T>
ACE_INLINE TAO_EC_Servant_Var< T > & TAO_EC_Servant_Var< T >::operator= | ( | T * | p | ) |

| Assignment operator. Assumes ownership of `p`.

template<class T>
ACE_INLINE TAO_EC_Servant_Var< T > & TAO_EC_Servant_Var< T >::operator= | ( | TAO_EC_Servant_Var< T > const & | rhs | ) |

| Assignment operator. Adds reference to `rhs`.

template<class T>
ACE_INLINE T *& TAO_EC_Servant_Var< T >::out | ( |  | ) |

| As an OUT parameter.

## Member Data Documentation

template<class T>
T* TAO_EC_Servant_Var< T >::ptr_`[private]`

The documentation for this class was generated from the following files:

- EC_Lifetime_Utils_T.h
- EC_Lifetime_Utils_T.i